unit fMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, OrbPing, OrbPingErrors, ExtCtrls, ComCtrls;

type
  TfrmMain = class(TForm)
    ThreadMonitorTimer: TTimer;
    Panel3: TPanel;
    OrbPing: TOrbPing;
    Label2: TLabel;
    Label14: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label1: TLabel;
    cboPingNameOrAddress: TComboBox;
    Button2: TButton;
    cboPingPriority: TComboBox;
    edtPingTimeout: TEdit;
    edtPingTTL: TEdit;
    edtPingDataSize: TEdit;
    Button5: TButton;
    edtPingThreads: TEdit;
    ResultList: TMemo;
    StatusBar1: TStatusBar;
    edtPingTag: TEdit;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ThreadMonitorTimerTimer(Sender: TObject);
    procedure OrbPingPingEvent(PingData: TPingData);
    procedure OrbPingErrorEvent(OrbError: TOrbError);
  private
    function GetThreadTypeFromString(AsThreadString: string): TThreadPriority;
  public
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

//form create
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  cboPingNameOrAddress.ItemIndex := 0;
  cboPingPriority.ItemIndex := 3;
end;


procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

end;

//get the thread priority
function TfrmMain.GetThreadTypeFromString(AsThreadString: string):
  TThreadPriority;
begin
  Result := tpNormal;
  if AsThreadString = 'tbIdle' then Result := tpIdle;
  if AsThreadString = 'tpLowest' then Result := tpLowest;
  if AsThreadString = 'tpLower' then Result := tpLower;
  if AsThreadString = 'tpNormal' then Result := tpNormal;
  if AsThreadString = 'tpHigher' then Result := tpHigher;
  if AsThreadString = 'tpHighest' then Result := tpHighest;
  if AsThreadString = 'tpTimeCritical' then Result := tpTimeCritical;
end;

//status timer
procedure TfrmMain.ThreadMonitorTimerTimer(Sender: TObject);
begin
  StatusBar1.Panels[1].Text := 'Active Threads: '
    + IntToStr(OrbPing.ThreadCount);
  If OrbPing.Active then
    StatusBar1.Panels[0].Text := 'Status: Tracing...'
  else
    StatusBar1.Panels[0].Text := 'Status: Idle';
end;

//ping
procedure TfrmMain.Button2Click(Sender: TObject);
begin
  ResultList.Lines.Clear;
  OrbPing.MaxThreads := StrToInt(Trim(edtPingThreads.Text));
  ResultList.lines.Add('>> Pinging... ' +  Trim(cboPingNameOrAddress.Text) +  '...');
  If not OrbPing.Ping(
    Trim(cboPingNameOrAddress.Text),
    Trim(edtPingTag.Text),
    StrToInt(edtPingTTL.Text),
    StrToInt(edtPingTimeout.Text),
    StrToInt(edtPingDataSize.Text),
    GetThreadTypeFromString(cboPingNameOrAddress.Items[
      cboPingNameOrAddress.ItemIndex])) then
    ResultList.Lines.Add('>> Ping Ignored due to Threadshortage.');
end;

//cancel all pings
procedure TfrmMain.Button5Click(Sender: TObject);
var
iPings: LongInt;
begin
  iPings := OrbPing.Cancel;
  Resultlist.Lines.Add('>> Pings Cancelled (' + IntToStr(iPings) + ' total)');
end;

//Ping event
procedure TfrmMain.OrbPingPingEvent(PingData: TPingData);
begin
  ResultList.Lines.Add('<< Ping Result: ' + PingData.Name + ' = ' +
    PingData.IP + ' Time: ' + IntToStr(PingData.ElapsedTime) + ' ms' +
    ' with Tag: ' + PingData.Tag);
end;

//error event
procedure TfrmMain.OrbPingErrorEvent(OrbError: TOrbError);
begin
  //error
  ResultList.lines.add('<< Ping Error: ' + IntToStr(OrbError.Code) + ','
    + OrbError.Description + ',' + OrbError.Verbose);
end; 



end.
