unit fMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, OrbResolve, OrbResolveErrors, ExtCtrls, ComCtrls,
  OrbPing;

type
  TfrmMain = class(TForm)
    ThreadMonitorTimer: TTimer;
    Panel3: TPanel;
    Label14: TLabel;
    Label17: TLabel;
    Label1: TLabel;
    cboResolveNameOrAddress: TComboBox;
    Button2: TButton;
    cboResolvePriority: TComboBox;
    Button5: TButton;
    edtResolveThreads: TEdit;
    ResultList: TMemo;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    edtResolveTag: TEdit;
    OrbResolve: TOrbResolve;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ThreadMonitorTimerTimer(Sender: TObject);
    procedure OrbResolveErrorEvent(OrbError: TOrbError);
    procedure OrbResolveResolveEvent(ResolveData: TResolveData);
  private
    function GetThreadTypeFromString(AsThreadString: string): TThreadPriority;
  public
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

//form create
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  cboResolveNameOrAddress.ItemIndex := 0;
  cboResolvePriority.ItemIndex := 3;

end;

//close form
procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

end;

//get the thread priority
function TfrmMain.GetThreadTypeFromString(AsThreadString: string):
  TThreadPriority;
begin
  Result := tpNormal;
  if AsThreadString = 'tbIdle' then Result := tpIdle;
  if AsThreadString = 'tpLowest' then Result := tpLowest;
  if AsThreadString = 'tpLower' then Result := tpLower;
  if AsThreadString = 'tpNormal' then Result := tpNormal;
  if AsThreadString = 'tpHigher' then Result := tpHigher;
  if AsThreadString = 'tpHighest' then Result := tpHighest;
  if AsThreadString = 'tpTimeCritical' then Result := tpTimeCritical;
end;

//status timer
procedure TfrmMain.ThreadMonitorTimerTimer(Sender: TObject);
begin
  StatusBar1.Panels[1].Text := 'Active Threads: '
    + IntToStr(OrbResolve.ThreadCount);
  If OrbResolve.Active then
    StatusBar1.Panels[0].Text := 'Status: Resolving...'
  else
    StatusBar1.Panels[0].Text := 'Status: Idle';
end;

//Resolve
procedure TfrmMain.Button2Click(Sender: TObject);
begin
  OrbResolve.MaxThreads := StrToInt(Trim(edtResolveThreads.Text));
  ResultList.lines.Add('>> Resolving... ' +  Trim(cboResolveNameOrAddress.Text) +  '...');
  If not OrbResolve.Resolve(Trim(cboResolveNameOrAddress.Text),
    GetThreadTypeFromString(cboResolveNameOrAddress.Items[
      cboResolveNameOrAddress.ItemIndex]), Trim(edtResolveTag.Text)) then
  ResultList.Lines.Add('>> Resolve Ignored due to Threadshortage.');
end;

//cancel all Resolves
procedure TfrmMain.Button5Click(Sender: TObject);
var
iResolves: LongInt;
begin
  iResolves := OrbResolve.Cancel;
  Resultlist.Lines.Add('>> Resolves Cancelled (' + IntToStr(iResolves) + ' total)');
end;

//error event
procedure TfrmMain.OrbResolveErrorEvent(OrbError: TOrbError);
begin
  ResultList.lines.add('<< Resolve Error: ' + IntToStr(OrbError.Code) + ','
    + OrbError.Description + ',' + OrbError.Verbose);
end;

//Resolve event
procedure TfrmMain.OrbResolveResolveEvent(ResolveData: TResolveData);
begin
  ResultList.Lines.Add('<< Resolve Result: ' + ResolveData.Name + ' = ' +
    ResolveData.IP + ' Tag: ' + ResolveData.Tag);
end;

end.
